<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class abuCron
{
    public static function createUserLdap($psUsername, $psDomaine) {
        $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $psDomaine);
        if ($oDomaine) {
            $nDomaine = $oDomaine->getId();
            $bResult = ldapsynch::authUser(sfConfig::get('app_ldap_cron_user'), sfConfig::get('app_ldap_cron_password'), $oDomaine);
            if ($bResult) {
                $user = Doctrine::getTable('sfGuardUser')->retrieveByUsernameDomaine($psUsername, $nDomaine);
                if (! $user)
                {
                  $user = new sfGuardUser;
                  $user->setUsername($psUsername);
                  $user->setIdDomaine($nDomaine);
                  $user->setSalt('unused');
                  $user->setPassword('unused');
                  $user->setEmailAddress(ldapsynch::getFieldUsername('mail', $psUsername));
                  $aNomComplet = explode("/", substr(ldapsynch::getFieldUsername('cn', $psUsername), 12));
                  $user->setFirstName($aNomComplet[0]);
                  $user->setLastName($aNomComplet[1]);
                  $user->save();
                }
                $user = Doctrine::getTable('sfGuardUser')->retrieveByUsernameDomaine($psUsername, $nDomaine);
                $bResp = ldapsynch::synchUser($user->getId(), $nDomaine, $psUsername);
                if (!$bResp) {
                  throw new Exception('Erreur synchronisation utilisateur '.$psUsername.' incorrecte');
                } else {
                  return $user;
                }
            } else {
              throw new Exception('Erreur impossible de se connecter sur le LDAP');                
            }
        } else {
            throw new Exception('Erreur domaine incorrecte');
        }
    }
    public static function editUserLdap($psUsername, $psDomaine) {
        $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $psDomaine);
        if ($oDomaine) {
            $nDomaine = $oDomaine->getId();
            $bResult = ldapsynch::authUser(sfConfig::get('app_ldap_cron_user'), sfConfig::get('app_ldap_cron_password'), $oDomaine);
            if ($bResult) {
                $user = Doctrine::getTable('sfGuardUser')->retrieveByUsernameDomaine($psUsername, $nDomaine);
                if ($user)
                {
                  $user->setEmailAddress(ldapsynch::getFieldUsername('mail', $psUsername));
                  $aNomComplet = explode("/", substr(ldapsynch::getFieldUsername('cn', $psUsername), 12));
                  $user->setFirstName($aNomComplet[0]);
                  $user->setLastName($aNomComplet[1]);
                  $user->save();
                }
                $bResp = ldapsynch::synchUser($user->getId(), $nDomaine, $psUsername);
                if (!$bResp) {
                  throw new Exception('Erreur synchronisation utilisateur '.$psUsername.' incorrecte');
                } else {
                  return $user;
                }
            } else {
              throw new Exception('Erreur impossible de se connecter sur le LDAP');                
            }
        } else {
            throw new Exception('Erreur domaine incorrecte');
        }
    }
    public static function createCahierTexte($poUser) {
        $oGroup = Doctrine::getTable('tbl_groupeuser')->findOneBy('id_sfguarduser', $poUser->getId());
        try {
            $oCahier = Doctrine::getTable('tbl_cahier_texte')->findBySql('id_user=?', array($poUser->getId()), Doctrine_Core::HYDRATE_RECORD);
            if ($oCahier->count() == 0) {             
                $oCahier = new tbl_cahier_texte();
                $oCahier->setIdUser($poUser->getId());
                $oCahier->setIdGroupe($oGroup->getIdGroupe());
                $oCahier->setLib('Cahier de texte '.ucfirst($poUser->getFirstName()).' '.ucfirst($poUser->getLastName()));
                $oCahier->save();
            } else {
              return $oCahier[0]->getId();
            }
        } catch (Exception $e) {
            throw new Exception('Erreur impossible d\'enregisrer le cahier de texte de '.$poUser->getUsername());
        }
        return $oCahier->getId();
    }
    public static function createCahierLiaison($poUser) {
        try {
            $oCahier = Doctrine::getTable('tbl_cahier_liaison')->findBySql('id_user=?', array($poUser->getId()), Doctrine_Core::HYDRATE_RECORD);
            if ($oCahier->count() == 0) { 
                $oCahier = new tbl_cahier_liaison();
                $oCahier->setIdUser($poUser->getId());
                $oCahier->setLib('Cahier de liaison '.ucfirst($poUser->getFirstName()).' '.ucfirst($poUser->getLastName()));
                $oCahier->save();
            } else {
              return $oCahier[0]->getId();
            }
        } catch (Exception $e) {
            throw new Exception('Erreur impossible d\'enregisrer le cahier de liaison de '.$poUser->getUsername());
        }
        return $oCahier->getId();
    }
    public static function addRespCahierLiaison($poUser) {
      $oCahier = Doctrine::getTable('tbl_cahier_liaison')->findOneBy('id_user', $poUser->getId());
      if ($oCahier) {
          $nCahier = $oCahier->getId();
          $oResps = Doctrine::getTable('sfGuardUser')->findResp($poUser, doctrine_core::HYDRATE_RECORD)->execute();
          foreach ($oResps as $oResp) {
              $oRespLiaison = Doctrine::getTable('tbl_responsable_liaison')->findBySql('id_user = ? and id_cahier_liaison = ?', array($oResp->getId(), $nCahier), doctrine_core::HYDRATE_RECORD);
              if ($oRespLiaison->count() == 0) {
                  $oRespLiaison = new tbl_responsable_liaison();
                  $oRespLiaison->setIdUser($oResp->getId());
                  $oRespLiaison->setIdCahierLiaison($nCahier);
                  $oRespLiaison->save();
              }
          }
          $oGroupeEnseignant = Doctrine::getTable('sfGuardGroup')->findOneBy('name', 'enseignants');
          $oGroup = Doctrine::getTable('tbl_groupeuser')->findOneBy('id_sfguarduser', $poUser->getId());
          $oRespsEnseignant = Doctrine::getTable('sfGuardUser')->findRespsGroup($oGroupeEnseignant->getId(), $oGroup->getIdGroupe())->execute();
          foreach ($oRespsEnseignant as $oRespEnseignant) {
              $oRespLiaison = Doctrine::getTable('tbl_responsable_liaison')->findBySql('id_user = ? and id_cahier_liaison = ?', array($oRespEnseignant->getId(), $nCahier), doctrine_core::HYDRATE_RECORD);
              if ($oRespLiaison->count() == 0) {
                  $oRespLiaison = new tbl_responsable_liaison();
                  $oRespLiaison->setIdUser($oRespEnseignant->getId());
                  $oRespLiaison->setIdCahierLiaison($nCahier);
                  $oRespLiaison->save();
              }
          }
      } else {
          throw new Exception('Erreur cahier de liaison introuvable ('.$poUser->getUsername().')');
      }
    }
}