<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class agendaActions extends sfActions
{
  public function preExecute(){
    parent::preExecute() ;
    if ($this->getUser()->hasGroup('eleves')) {
        $this->redirect('@homepage');
    }
    $this->arrayCulture = sfConfig::get("sf_ks_wd_calendar_plugin") ;
    $this->arrayCulture = $this->arrayCulture['culture'];
  }
  public function executeAccueil(sfWebRequest $request) {
  }
  public function executeIndex(sfWebRequest $request)
  {
    $nIdCalendrier = $this->getUser()->getIdCalendrier();
    $this->ks_wc_events = Doctrine_Core::getTable('KsWCEvent')
      ->createQuery('a')
      ->where('a.id_calendrier = '.$nIdCalendrier)
      ->execute();
    $this->form = new KsWCEventForm();
  }
  public function executeList(sfWebRequest $request){
    $nIdCalendrier = $this->getUser()->getIdCalendrier();
    $start_day = (string)$request->getParameter('showdate', '');
    $type      = (string)$request->getParameter('viewtype', 'month');
    $this->events = array();
    $this->issort = true;
    $this->start  = null;
    $this->end    = null;
    $this->error  = null;
    try {
      $php_time = ksWdCalendar::js2PhpTime($start_day, $this->arrayCulture['fulldaykey']);
      switch ($type) {
        case 'month':
          $start_time = mktime(0, 0, 0, date('m', $php_time), 1, date('Y', $php_time));
          $end_time   = mktime(0, 0, -1, date('m', $php_time)+1, 1, date('Y', $php_time));
          break;
        case 'week':
          $monday  =  date('d', $php_time) - date('N', $php_time) + 1;
          $start_time = mktime(0, 0, 0, date('m', $php_time), $monday, date('Y', $php_time));
          $end_time   = mktime(0, 0, -1, date('m', $php_time), $monday + 7, date('Y', $php_time));
          break;
        case 'day':
          $start_time = mktime(0, 0, 0, date('m', $php_time), date('d', $php_time), date('Y', $php_time));
          $end_time   = mktime(0, 0, -1, date('m', $php_time), date('d', $php_time) + 1, date('Y', $php_time));
          break;
        default:
          throw new sfException('Le type du calendrier demandé n\'est pas connu');
      }
      $this->start  = ksWdCalendar::php2JsTime($start_time , $this->arrayCulture['jsdate']);
      $this->end    = ksWdCalendar::php2JsTime($end_time , $this->arrayCulture['jsdate']);      
      $start_time = date("Y-m-d H:i:s" , $start_time) ;
      $end_time = date("Y-m-d H:i:s" , $end_time) ;
      $q = Doctrine_Query::create()
        ->select('a.*')
        ->from('KsWCEvent a')
        ->where("(start_time BETWEEN ? AND ?) OR (end_time BETWEEN ? AND ?)" , Array($start_time , $end_time , $start_time , $end_time ))
        ->andWhere('id_calendrier = '.$nIdCalendrier)
        ;
      foreach($q->execute() as $event){
        $this->events[] = array(
          $event->getId(),
          $event->getSubject(),
          ksWdCalendar::php2JsTime($event->getStartTime(null) , $this->arrayCulture['jsdate']),
          ksWdCalendar::php2JsTime($event->getEndTime(null) , $this->arrayCulture['jsdate']),
          $event->getIsAllDayEvent(),
          0,
          $event->getRecurringRule(),
          $event->getColor(),
          1,
          '',
        );
      }
    } catch (Exception $e) {
      $this->error = $e->getMessage();
    }
  }
  public function executeShow(sfWebRequest $request)
  {
    $this->ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id')));
    $this->forward404Unless($this->ks_wc_event);
  }
  public function executeNew(sfWebRequest $request)
  {
    $this->setLayout(false);
    $this->form = new KsWCEventForm();
  }
  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod(sfRequest::POST));
    $this->form = new KsWCEventForm();
    $this->processForm($request, $this->form);
    $this->setTemplate('update');
  }
  public function executeEdit(sfWebRequest $request)
  {
    $this->setLayout(false) ;
    if( !($ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id'))))){
        $ks_wc_event = new KsWCEvent() ;
        $ks_wc_event->setStartTime($request->getParameter('start')) ;
        $ks_wc_event->setEndTime($request->getParameter('end')) ;
        $ks_wc_event->setSubject($request->getParameter('title')) ;
        $ks_wc_event->setDescription($request->getParameter('description')) ;
        $ks_wc_event->setIsAllDayEvent($request->getParameter('isallday')) ;
        $ks_wc_event->setIdCalendrier($request->getParameter('id_calendrier')) ;
    }
    $this->form = new KsWCEventForm($ks_wc_event);
    sfConfig::set('sf_web_debug', false) ;
    if($this->form->getObject()->isNew()){
        $this->setTemplate("new") ;
        return ;
    }
  }
  public function executeUpdate(sfWebRequest $request){
    $this->forward404Unless($request->isMethod(sfRequest::POST) || $request->isMethod(sfRequest::PUT));
    $this->forward404Unless($ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id'))), sprintf('Object ks_wc_event does not exist (%s).', $request->getParameter('id')));
    $this->form = new KsWCEventForm($ks_wc_event);
    $this->processForm($request, $this->form);
    sfConfig::set('sf_web_debug', false) ;
    $this->setLayout(false);
    $this->setTemplate('update');
  }
  public function executeDelete(sfWebRequest $request)
  {
    $this->forward404Unless($ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id'))), sprintf('Object ks_wc_event does not exist (%s).', $request->getParameter('id')));
    $ks_wc_event->delete();
    $this->success = true ;
    $this->message = "Event deleted" ;
  }
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $isNew = $form->getObject()->isNew() ;
    $arrayParams = $request->getParameter($form->getName()) ;
    if(!isset($arrayParams['subject'])){
      $arrayParams['subject'] = $form->getObject()->getSubject() ;
    }
    if(!isset($arrayParams['description'])){
      $arrayParams['description'] = $form->getObject()->getDescription() ;
    }
    $nIdCalendrier = $this->getUser()->getIdCalendrier();
    if(!isset($arrayParams['id_calendrier'])){
      $arrayParams['id_calendrier'] = $nIdCalendrier ;
    }
    $form->bind($arrayParams, $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $ks_wc_event = $form->save();
      $this->success = true ;
      $this->message = (($isNew)?"Ajouter évènement":"Modifier évènement") ;
      $this->data = $form->getObject()->getId();   
    } else {
        $this->success = false ;
        $this->message = '';
        foreach ($form as $widget) {
          if ($widget->hasError()) {
	   $this->message .=  $widget->getError();
          }
	}
        $this->data =  $form->getObject()->getId();  
    }
  }
  public function executeEditAjax(sfWebRequest $request) {
      if ($request->isXmlHttpRequest()) {
        if( !($ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id'))))){
            $ks_wc_event = new KsWCEvent() ;
            $ks_wc_event->setStartTime($request->getParameter('start')) ;
            $ks_wc_event->setEndTime($request->getParameter('end')) ;
            $ks_wc_event->setSubject($request->getParameter('title')) ;
            $ks_wc_event->setDescription($request->getParameter('description')) ;
            $ks_wc_event->setIsAllDayEvent($request->getParameter('isallday')) ;
            $ks_wc_event->setIdCalendrier($request->getParameter('id_calendrier')) ;
        }          
        $form = new KsWCEventForm($ks_wc_event);
        return $this->renderPartial('agenda/form', array('form' => $form));       
      }
      $this->redirect404();      
  }
  public function executeNewAjax(sfWebRequest $request) {
     if ($request->isXmlHttpRequest()) {
       $form = new KsWCEventForm();
       return $this->renderPartial('agenda/form', array('form' => $form));       
     }
     $this->redirect404();      
  }
  public function executeShowAjax(sfWebRequest $request) {
     if ($request->isXmlHttpRequest()) {
       if ($request->hasParameter('id')) {
           $oEvenement = Doctrine::getTable('KsWCEvent')->find($request->getParameter('id'));
           if ($oEvenement) {
               return $this->renderPartial('agenda/show', array('oEvenement' => $oEvenement)); 
           }
       }              
     }
     $this->redirect404();      
  }  
  public function executeDeleteEventAjax(sfWebRequest $request)
  {
    if ($request->isXmlHttpRequest()) {
      $this->getResponse()->setHttpHeader('Content-Type', 'application/json;');
      $time = microtime(true);        
      $this->forward404Unless($ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id'))), sprintf('Object ks_wc_event does not exist (%s).', $request->getParameter('id')));
      $ks_wc_event->delete();
      $jsonresponse = "ok";
      return $this->renderText(json_encode($jsonresponse));       
    }
    $this->redirect404();      
  }
  public function executeEditEventAjax(sfWebRequest $request)
  {
    if ($request->isXmlHttpRequest()) {
      $this->forward404Unless($request->isMethod(sfRequest::POST));  
      $this->forward404Unless($ks_wc_event = Doctrine_Core::getTable('KsWCEvent')->find(array($request->getParameter('id'))), sprintf('Object ks_wc_event does not exist (%s).', $request->getParameter('id')));
      $this->form = new KsWCEventForm($ks_wc_event);
      $this->processForm($request, $this->form);
      return $this->renderPartial('agenda/form', array('form' => $form));
    } 
    $this->redirect404();      
  }  
}
