<?php
require_once dirname(__FILE__).'/../lib/groupeclasseGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/groupeclasseGeneratorHelper.class.php';
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class groupeclasseActions extends autoGroupeclasseActions
{
  public function executeDelete(sfWebRequest $request)
  {
    $this->tbl_groupe = $this->getRoute()->getObject();
    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
    if ($oUser->hasCredential('admin')) {
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->tbl_groupe->getIdDomaine() != $nDomaine) {
        $this->redirect('@tbl_groupe');
      }
    } else {
      $this->redirect('@tbl_groupe');
    }
    parent::executeDelete($request);
  }
  public function executeEdit(sfWebRequest $request)
  {
    $this->tbl_groupe = $this->getRoute()->getObject();
    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
    if ($oUser->hasCredential('admin')) {
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->tbl_groupe->getIdDomaine() != $nDomaine) {
        $this->redirect('@tbl_groupe');
      }
    } else {
      $this->redirect('@tbl_groupe');
    }
    $this->form = $this->configuration->getForm($this->tbl_groupe);
  }
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';
      try {
        $tbl_groupe = $form->save();
        if (!$this->getUser()->isSuperAdmin()) {
            $oNewUser = Doctrine::getTable('tbl_groupe')->find($tbl_groupe->getId());
            $oNewUser->setIdDomaine($this->getUser()->getDomaine());
            $oNewUser->save();
        }
      } catch (Doctrine_Validator_Exception $e) {
        $errorStack = $form->getObject()->getErrorStack();
        $message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
        foreach ($errorStack as $field => $errors) {
            $message .= "$field (" . implode(", ", $errors) . "), ";
        }
        $message = trim($message, ', ');
        $this->getUser()->setFlash('error', $message);
        return sfView::SUCCESS;
      }
      $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $tbl_groupe)));
      if ($request->hasParameter('_save_and_add'))
      {
        $this->getUser()->setFlash('notice', $notice.' You can add another one below.');
        $this->redirect('@tbl_groupe_new');
      }
      else
      {
        $this->getUser()->setFlash('notice', $notice);
        $this->redirect(array('sf_route' => 'tbl_groupe_edit', 'sf_subject' => $tbl_groupe));
      }
    }
    else
    {
      $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
    }
  }
}
