<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class mainActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
  }
  public function execute404(sfWebRequest $request)
  {
  }
  public function executeMonCompte(sfWebRequest $request)
  {
      $this->oUser = $this->getUser()->getGuardUser();
      $this->aGroupe = $this->getUser()->getGroupeClasseLib();
      $oDomaine = $this->oUser->getTblDomaine();
      $nUser = $this->oUser->getId();  
      $this->sAvatarClient = $this->oUser->getAvatar();
      if ($this->oUser->getAvatar() == "") {
          $this->sImage = '/images/avatars/avatar_defaut.png';          
      } else {
          $this->sImage = '/images/avatars/'.DIRECTORY_SEPARATOR.$this->oUser->getAvatar();
      }
      $this->aAvatars = avatar::getAvatarFiles(sfConfig::get('sf_web_dir').DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.'avatars');
  }
  public function executeAvatarAjax(sfWebRequest $request) {
      $this->getResponse()->setHttpHeader('Content-Type', 'application/json;');
      $time = microtime(true);
      $sAvatar = $this->getRequest()->getParameter('sAvatar');
      $jsonresponse = array();
      $oUser = $this->getUser()->getGuardUser();
      $oUser->setAvatar($sAvatar);
      $oUser->save();    
      $jsonresponse['avatar'] = '/images/avatars/'.$sAvatar;
      return $this->renderText(json_encode($jsonresponse));
  }  
  public function executePlusOutils(sfWebRequest $request)
  {
      if ($_SERVER['SERVER_NAME'] == sfConfig::get('app_host_cas')) {
          $this->aEssentiel = sfConfig::get('app_outils_bloc_essentiel');
          $this->aComplementaire = sfConfig::get('app_outils_bloc_complementaire');
          $this->setTemplate('plusOutilsPortail');
      } else {
          $this->aEssentiel = sfConfig::get('app_outils_bloc_essentiel');
          $this->aComplementaire = sfConfig::get('app_outils_bloc_complementaire');
          $this->setTemplate('plusOutilsPortail');
      }
  }  
  public function executeCompatibility(sfWebRequest $request)
  {
  }
  public function executeCronLdapUser(sfWebRequest $request)
  {
      $this->setLayout(false);
      $this->getResponse()->setStatusCode(400);
      if ($request->getParameter('username') && $request->getParameter('domaine')) {
         $sUsername = $request->getParameter('username');
         $sDomaine = $request->getParameter('domaine');
         $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $sDomaine);
         if ($oDomaine) {
           $nDomaine = $oDomaine->getId();
           $user = Doctrine::getTable('sfGuardUser')->retrieveByUsernameDomaine($sUsername, $nDomaine);
           if (ldapsynch::authUser(sfConfig::get('app_ldap_cron_user'), sfConfig::get('app_ldap_cron_password'), $oDomaine)) {
               $nUid = ldapsynch::getFieldUsername('uidnumber', $sUsername);
               if ($nUid != '') {
                   if (! $user)
                   {
                      $user = new sfGuardUser;
                      $user->setUsername($sUsername);
                      $user->setIdDomaine($nDomaine);
                      $user->setSalt('unused');
                      $user->setPassword('unused');
                      $user->setEmailAddress(ldapsynch::getFieldUsername('mail', $sUsername));
                      $aNomComplet = explode("/", substr(ldapsynch::getFieldUsername('cn', $sUsername), 12));
                      $user->setFirstName($aNomComplet[0]);
                      $user->setLastName($aNomComplet[1]);
                      $user->save();
                   }
                   $bResp = ldapsynch::synchUser($user->getId(), $nDomaine, $sUsername);
                   $this->getResponse()->setStatusCode(200);
               }
           }
         }          
      }      
  }
  public function executeArbre(sfWebRequest $request)
  {
  }  
  public function executeHeader(sfWebRequest $request) {
  }
  public function executeFooter(sfWebRequest $request) {
  }  
}
