<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class messageActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {    
    $this->redirect('@messagerie');
  }
  public function executeNew(sfWebRequest $request)
  {  
    if ($request->hasParameter('id_message')) {
        $nMessage = $request->getParameter('id_message');
    }
    $this->form = new messageClassiqueForm(array(), array('id_message' => isset($nMessage)?$nMessage:''));
  }
  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod(sfRequest::POST));
    $this->form = new messageClassiqueForm();
    $this->processForm($request, $this->form);
    $this->setTemplate('new');
  }
  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($tbl_message = Doctrine_Core::getTable('tbl_message')->find(array($request->getParameter('id'))), sprintf('Object tbl_message does not exist (%s).', $request->getParameter('id')));
    $this->form = new messageClassiqueForm($tbl_message);
  }
  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod(sfRequest::POST) || $request->isMethod(sfRequest::PUT));
    $this->forward404Unless($tbl_message = Doctrine_Core::getTable('tbl_message')->find(array($request->getParameter('id'))), sprintf('Object tbl_message does not exist (%s).', $request->getParameter('id')));
    $this->form = new messageClassiqueForm($tbl_message);
    $this->processForm($request, $this->form);
    $this->setTemplate('edit');
  }
  public function executeDelete(sfWebRequest $request)
  {
    $request->checkCSRFProtection();
    $this->forward404Unless($tbl_message = Doctrine_Core::getTable('tbl_message')->find(array($request->getParameter('id'))), sprintf('Object tbl_message does not exist (%s).', $request->getParameter('id')));
    $tbl_message->delete();
    $this->redirect('message/index');
  }
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $aValues = $form->getValues();
      $data['id_userfrom'] = $aValues['id_userfrom'];
      $data['sujet'] = $aValues['sujet'];
      $data['message'] = $aValues['message'];
      $data['confidentiel'] = $aValues['confidentiel'];
      $data['id_priorite'] = $aValues['id_priorite'];
      $data['date_evenement'] = $aValues['date_evenement'];
      if (isset($aValues['id_message'])) {
          $record = Doctrine_Core::getTable('tbl_message')->find($aValues['id_message']);
          $oMessage = new tbl_message;
          foreach ($data as $key => $value) {
            $oMessage->set($key, $value);
          }
          $record->getNode()->addChild($oMessage);
          if ($record->getConfidentiel()) {
              $oMessage->setConfidentiel(true);
          }
          $oMessage->save();
          $oRoot = Doctrine::getTable('tbl_message')->find($record->getRootId());
          $oRoot->setUpdatedAt($oMessage->getUpdatedAt());
          $oRoot->save();
      } else {
          $oMessage = new tbl_message;
          $oMessage->synchronizeWithArray( $data );
                        $oMessage->save();
          Doctrine_Core::getTable('tbl_message')->getTree()->createRoot($oMessage);
      }
      $aUsers = $aValues['id_user'];
      $sMailFrom = $this->getUser()->getEmail();
      foreach ($aUsers as $key => $value) {
          $oUser = Doctrine::getTable('sfGuardUser')->find($value);
          $oMessageFor = new tbl_message_for();
          $oMessageFor->setIdUser($value);
          $oMessageFor->setIdMessage($oMessage->getId());
          $oMessageFor->save();
          $bResult = $this->sendMessage($sMailFrom, $oUser);
      }
      $this->redirect('@messagerie');
    }
  }
  private function sendMessage($psMailFrom, $poUser) {
        $sMailTo = $poUser->getEmailAddress();
        $message = Swift_Message::newInstance();
        if (sfConfig::get('sf_environment') != 'test') {
          $cid = $message->embed(Swift_Image::fromPath('images/logo_mail.png'));
        } else {
          $cid = "";
        }
        $message->setFrom($psMailFrom);
        $message->setTo($sMailTo);
        $message->setSubject('Abuledu ENT message');
        $message->setBody($this->getPartial('messageClassique', $arguments = array('cid' => $cid,
                                                                                 'oUser' => $poUser), 'text/html' ));
        $message->setContentType('text/html');
        $this->getMailer()->send($message);
        return true;
  }
}
