<?php
require_once dirname(__FILE__).'/../lib/sfGuardUserGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/sfGuardUserGeneratorHelper.class.php';
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class sfGuardUserActions extends autoSfGuardUserActions
{
  public function executeDelete(sfWebRequest $request)
  {
    $this->sf_guard_user = $this->getRoute()->getObject();
    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
    if ($oUser->hasCredential('admin')) {
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->sf_guard_user->getIdDomaine() != $nDomaine) {
        $this->redirect('@sf_guard_user');
      }
    } else {
      $this->redirect('@sf_guard_user');
    }
    parent::executeDelete($request);
  }
  public function executeEdit(sfWebRequest $request)
  {
    $this->sf_guard_user = $this->getRoute()->getObject();
    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
    if ($oUser->hasCredential('admin')) {
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->sf_guard_user->getIdDomaine() != $nDomaine) {
        $this->redirect('@sf_guard_user');
      }
    } else {
      $this->redirect('@sf_guard_user');
    }
    $this->form = $this->configuration->getForm($this->sf_guard_user);
  }
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';
      try {        
        $sf_guard_user = $form->save();
        if (!$this->getUser()->isSuperAdmin()) {
            $oNewUser = Doctrine::getTable('sfGuardUser')->find($sf_guard_user->getId());
            $oNewUser->setIdDomaine($this->getUser()->getDomaine());
            $oNewUser->save();
        }
      } catch (Doctrine_Validator_Exception $e) {
        $errorStack = $form->getObject()->getErrorStack();
        $message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
        foreach ($errorStack as $field => $errors) {
            $message .= "$field (" . implode(", ", $errors) . "), ";
        }
        $message = trim($message, ', ');
        $this->getUser()->setFlash('error', $message);
        return sfView::SUCCESS;
      }
      $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $sf_guard_user)));
      if ($request->hasParameter('_save_and_add'))
      {
        $this->getUser()->setFlash('notice', $notice.' You can add another one below.');
        $this->redirect('@sf_guard_user_new');
      }
      else
      {
        $this->getUser()->setFlash('notice', $notice);
        $this->redirect(array('sf_route' => 'sf_guard_user_edit', 'sf_subject' => $sf_guard_user));
      }
    }
    else
    {
      $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
    }
  }
  public function executeEditpassword(sfWebRequest $request) {
    $this->form = new ModifpasswordForm();
    if ($request->isMethod('post')) {
        $this->form->bind($request->getParameter('modifpassword'));
        if ($this->form->isValid())
        {
           $aValues = $this->form->getValues();
           $oUser = $this->getUser();
           $nDomaine =  $oUser->getDomaine();
           $oDomaine = Doctrine::getTable('tbl_domaine')->find($nDomaine);
           if ($oDomaine->getIsLdap()) {
               $sUsername = $oUser->getUsername();
               $bCheck = ldapsynch::setPassword($sUsername, $aValues['password_old'], $oDomaine, $aValues['password_forgot']);
           } else {
             $oUser->setPassword($aValues['password_forgot']);
           }
           $this->redirect('main/index');
        }
    }
  }
}
