<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class Basetbl_messageFormFilter extends BaseFormFilterDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'sujet'             => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'message'           => new sfWidgetFormFilterInput(),
      'id_userfrom'       => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('sfGuardUser'), 'add_empty' => true)),
      'id_cahier_liaison' => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_cahier_liaison'), 'add_empty' => true)),
      'confidentiel'      => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'date_evenement'    => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
      'id_message'        => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_message'), 'add_empty' => true)),
      'id_priorite'       => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_priorite'), 'add_empty' => true)),
      'root_id'           => new sfWidgetFormFilterInput(),
      'lft'               => new sfWidgetFormFilterInput(),
      'rgt'               => new sfWidgetFormFilterInput(),
      'level'             => new sfWidgetFormFilterInput(),
      'created_at'        => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => false)),
      'updated_at'        => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => false)),
    ));
    $this->setValidators(array(
      'sujet'             => new sfValidatorPass(array('required' => false)),
      'message'           => new sfValidatorPass(array('required' => false)),
      'id_userfrom'       => new sfValidatorDoctrineChoice(array('required' => false, 'model' => $this->getRelatedModelName('sfGuardUser'), 'column' => 'id')),
      'id_cahier_liaison' => new sfValidatorDoctrineChoice(array('required' => false, 'model' => $this->getRelatedModelName('tbl_cahier_liaison'), 'column' => 'id')),
      'confidentiel'      => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'date_evenement'    => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 00:00:00')), 'to_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 23:59:59')))),
      'id_message'        => new sfValidatorDoctrineChoice(array('required' => false, 'model' => $this->getRelatedModelName('tbl_message'), 'column' => 'id')),
      'id_priorite'       => new sfValidatorDoctrineChoice(array('required' => false, 'model' => $this->getRelatedModelName('tbl_priorite'), 'column' => 'id')),
      'root_id'           => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'lft'               => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'rgt'               => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'level'             => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'created_at'        => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 00:00:00')), 'to_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 23:59:59')))),
      'updated_at'        => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 00:00:00')), 'to_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 23:59:59')))),
    ));
    $this->widgetSchema->setNameFormat('tbl_message_filters[%s]');
    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    $this->setupInheritance();
    parent::setup();
  }
  public function getModelName()
  {
    return 'tbl_message';
  }
  public function getFields()
  {
    return array(
      'id'                => 'Number',
      'sujet'             => 'Text',
      'message'           => 'Text',
      'id_userfrom'       => 'ForeignKey',
      'id_cahier_liaison' => 'ForeignKey',
      'confidentiel'      => 'Boolean',
      'date_evenement'    => 'Date',
      'id_message'        => 'ForeignKey',
      'id_priorite'       => 'ForeignKey',
      'root_id'           => 'Number',
      'lft'               => 'Number',
      'rgt'               => 'Number',
      'level'             => 'Number',
      'created_at'        => 'Date',
      'updated_at'        => 'Date',
    );
  }
}
