<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class tbl_cahier_texteFormFilter extends Basetbl_cahier_texteFormFilter
{
  public function configure()
  {
    parent::configure();
    $oUser = sfContext::getInstance()->getUser();
    unset($this['created_at'], $this['updated_at']);
    if (($oUser->hasCredential('admin_domaine') || $oUser->hasCredential('resp_groupe')) && $oUser->hasCredential('admin') == false) {
      $qUserValide = $this->getUserValideQuery($oUser);
      $this->widgetSchema['id_user'] =  new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('sfGuardUser'),
                                                                                                                          'add_empty' => true,
                                                                                                                          'query' => $qUserValide));
      $qGroupValide = $this->getGroupValideQuery($oUser);
      $this->widgetSchema['id_groupe'] =  new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_groupe'),
                                                                                                                          'add_empty' => true,
                                                                                                                          'query' => $qGroupValide));
    } else {
        unset($this['id_user'], $this['id_groupe']);
    }
  }
  public function getUserValideQuery(sfBasicSecurityUser $poUser) {
    $query = Doctrine::getTable('sfGuardUser')->createQuery('c');
    $nDomaine =  $poUser->getDomaine();
    if ($poUser->hasCredential('admin_domaine'))
    {
      $oGroups = Doctrine::getTable('sfGuardGroup')->findBySql('name in ?', array(array('responsable-legal', 'enseignants', 'admin', 'resp')), Doctrine_core::HYDRATE_RECORD);
      $aGroup = array();
      foreach ($oGroups as $oGroup) {
          $aGroup[] = $oGroup->getId();
      }
      $query->where('c.id_domaine = '.$nDomaine);
      $query->leftJoin('c.tbl_groupeuser ug');
      $query->andWhere('ug.id_sfguarduser != ?', $poUser->getId());
      $query->leftJoin('c.sfGuardUserGroup ugg');
      $query->andWhereNotIn('ugg.group_id', $aGroup);
    } elseif ($poUser->hasCredential('resp_groupe')) {
      $oGroups = Doctrine::getTable('sfGuardGroup')->findBySql('name in ?', array(array('responsable-legal', 'enseignants', 'admin', 'resp')), Doctrine_core::HYDRATE_RECORD);
      $aGroupResp = array();
      foreach ($oGroups as $oGroup) {
          $aGroupResp[] = $oGroup->getId();
      }
      $aGroupe = $poUser->getGroupeClasse();
      if (empty($aGroupe)) {
        $query->where('c.id = '.$poUser->getGuardUser()->getId());
      } else {
        $query->where('c.id_domaine = '.$nDomaine);
        $query->leftJoin('c.tbl_groupeuser ug');
        $query->andWhereIn('ug.id_groupe', $aGroupe);
        $query->andWhere('ug.id_sfguarduser != ?', $poUser->getId());
        $query->leftJoin('c.sfGuardUserGroup ugg');
        $query->andWhereNotIn('ugg.group_id', $aGroupResp);
      }
    }
    return $query;
  }
  public function getGroupValideQuery(sfBasicSecurityUser $poUser) {
    $query = Doctrine::getTable('tbl_groupe')->createQuery('g');
    $nDomaine =  $poUser->getDomaine();
    if ($poUser->hasCredential('admin_domaine'))
    {
      $query->where('g.id_domaine = '.$nDomaine);
      $query->andWhere('g.titre NOT LIKE "'.sfConfig::get('app_prefixe_resp_legal').'%"');
    } elseif ($poUser->hasCredential('resp_groupe')) {
      $aGroupe = $poUser->getGroupeClasse();
      $query->where('g.id_domaine = '.$nDomaine);
      if (empty($aGroupe)) {
        $query->andWhereIn('id', array());
      } else {
        $query->andWhereIn('id', $aGroupe);
      }
    }
    return $query;
  }
}
