<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class Basetbl_messageForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                => new sfWidgetFormInputHidden(),
      'sujet'             => new sfWidgetFormInputText(),
      'message'           => new sfWidgetFormTextarea(),
      'id_userfrom'       => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('sfGuardUser'), 'add_empty' => false)),
      'id_cahier_liaison' => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_cahier_liaison'), 'add_empty' => true)),
      'confidentiel'      => new sfWidgetFormInputCheckbox(),
      'date_evenement'    => new sfWidgetFormDateTime(),
      'id_message'        => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_message'), 'add_empty' => true)),
      'id_priorite'       => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_priorite'), 'add_empty' => true)),
      'root_id'           => new sfWidgetFormInputText(),
      'lft'               => new sfWidgetFormInputText(),
      'rgt'               => new sfWidgetFormInputText(),
      'level'             => new sfWidgetFormInputText(),
      'created_at'        => new sfWidgetFormDateTime(),
      'updated_at'        => new sfWidgetFormDateTime(),
    ));
    $this->setValidators(array(
      'id'                => new sfValidatorChoice(array('choices' => array($this->getObject()->get('id')), 'empty_value' => $this->getObject()->get('id'), 'required' => false)),
      'sujet'             => new sfValidatorString(array('max_length' => 200)),
      'message'           => new sfValidatorString(array('max_length' => 5000, 'required' => false)),
      'id_userfrom'       => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('sfGuardUser'))),
      'id_cahier_liaison' => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_cahier_liaison'), 'required' => false)),
      'confidentiel'      => new sfValidatorBoolean(array('required' => false)),
      'date_evenement'    => new sfValidatorDateTime(array('required' => false)),
      'id_message'        => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_message'), 'required' => false)),
      'id_priorite'       => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_priorite'), 'required' => false)),
      'root_id'           => new sfValidatorInteger(array('required' => false)),
      'lft'               => new sfValidatorInteger(array('required' => false)),
      'rgt'               => new sfValidatorInteger(array('required' => false)),
      'level'             => new sfValidatorInteger(array('required' => false)),
      'created_at'        => new sfValidatorDateTime(),
      'updated_at'        => new sfValidatorDateTime(),
    ));
    $this->widgetSchema->setNameFormat('tbl_message[%s]');
    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    $this->setupInheritance();
    parent::setup();
  }
  public function getModelName()
  {
    return 'tbl_message';
  }
}
