<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class KsWCEventForm extends PluginKsWCEventForm
{
  public function configure()
  {
      parent::configure();
      unset($this['color'], $this['recurring_rule']);
      $oUser = sfContext::getInstance()->getUser();
      $nIdCalendrier = $oUser->getIdCalendrier();
      $this->widgetSchema['start_time'] = new sfWidgetFormI18nDateTime(array('culture' => 'fr', 'date' => array('format' => '%day%/%month%/%year%'), 'time' => array('format' => '%hour%:%minute%')));      
      $this->widgetSchema['end_time'] = new sfWidgetFormI18nDateTime(array('culture' => 'fr', 'date' => array('format' => '%day%/%month%/%year%'), 'time' => array('format' => '%hour%:%minute%')));      
      $this->widgetSchema['description']      = new sfWidgetFormTextarea(array(), array('cols' => '60', 'rows' => '10'));
      $this->validatorSchema['description'] = new sfValidatorString(array('max_length' => 4000, 'required' => false));
      $this->widgetSchema['id_calendrier'] = new sfWidgetFormInputHidden();  
      $this->widgetSchema['is_all_day_event'] = new sfWidgetFormInputCheckbox(array(), array('id' => 'IsAllDayEvent'));
      $this->validatorSchema['is_all_day_event'] = new sfValidatorBoolean(array('required' => false));
      $this->validatorSchema['subject']          = new sfValidatorString(array('required' => true), array('required' => 'Saisir un titre'));
      $this->widgetSchema->setLabels(array('start_time' => 'Heure départ', 'end_time' => 'Heure fin', 'is_all_day_event' => 'Toute la journée', 'subject' => 'Titre'));
      $this->setDefault('id_calendrier' , $nIdCalendrier);
      $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
  }
}
