<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class Basetbl_message extends sfDoctrineRecord
{
    public function setTableDefinition()
    {
        $this->setTableName('tbl_message');
        $this->hasColumn('id', 'integer', 8, array(
             'type' => 'integer',
             'primary' => true,
             'autoincrement' => true,
             'length' => 8,
             ));
        $this->hasColumn('sujet', 'string', 200, array(
             'type' => 'string',
             'notnull' => true,
             'length' => 200,
             ));
        $this->hasColumn('message', 'string', 5000, array(
             'type' => 'string',
             'length' => 5000,
             ));
        $this->hasColumn('id_userfrom', 'integer', null, array(
             'type' => 'integer',
             'notnull' => true,
             ));
        $this->hasColumn('id_cahier_liaison', 'integer', null, array(
             'type' => 'integer',
             ));
        $this->hasColumn('confidentiel', 'boolean', null, array(
             'type' => 'boolean',
             ));
        $this->hasColumn('date_evenement', 'timestamp', null, array(
             'type' => 'timestamp',
             ));
        $this->hasColumn('id_message', 'integer', null, array(
             'type' => 'integer',
             ));
        $this->hasColumn('id_priorite', 'integer', null, array(
             'type' => 'integer',
             ));
    }
    public function setUp()
    {
        parent::setUp();
        $this->hasOne('sfGuardUser', array(
             'local' => 'id_userfrom',
             'foreign' => 'id',
             'onDelete' => 'CASCADE'));
        $this->hasOne('tbl_cahier_liaison', array(
             'local' => 'id_cahier_liaison',
             'foreign' => 'id',
             'onDelete' => 'CASCADE'));
        $this->hasOne('tbl_message', array(
             'local' => 'id_message',
             'foreign' => 'id'));
        $this->hasOne('tbl_priorite', array(
             'local' => 'id_priorite',
             'foreign' => 'id'));
        $this->hasMany('tbl_message as tbl_reponse_message', array(
             'local' => 'id',
             'foreign' => 'id_message'));
        $nestedset0 = new Doctrine_Template_NestedSet(array(
             'hasManyRoots' => true,
             'rootColumnName' => 'root_id',
             ));
        $timestampable0 = new Doctrine_Template_Timestampable();
        $this->actAs($nestedset0);
        $this->actAs($timestampable0);
    }
}