<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class BaseKsWCEvent extends sfDoctrineRecord
{
    public function setTableDefinition()
    {
        $this->setTableName('ks_w_c_event');
        $this->hasColumn('subject', 'varchar', 64, array(
             'type' => 'varchar',
             'notnull' => false,
             'length' => 64,
             ));
        $this->hasColumn('description', 'string', 4000, array(
             'type' => 'string',
             'notnull' => false,
             'length' => 4000,
             ));
        $this->hasColumn('start_time', 'timestamp', null, array(
             'type' => 'timestamp',
             'notnull' => false,
             ));
        $this->hasColumn('end_time', 'timestamp', null, array(
             'type' => 'timestamp',
             'notnull' => false,
             ));
        $this->hasColumn('is_all_day_event', 'boolean', null, array(
             'type' => 'boolean',
             'default' => false,
             ));
        $this->hasColumn('color', 'varchar', 10, array(
             'type' => 'varchar',
             'length' => 10,
             ));
        $this->hasColumn('recurring_rule', 'varchar', 255, array(
             'type' => 'varchar',
             'length' => 255,
             ));
        $this->hasColumn('id_calendrier', 'integer', null, array(
             'type' => 'integer',
             'notnull' => true,
             ));
    }
    public function setUp()
    {
        parent::setUp();
        $this->hasOne('tbl_calendrier', array(
             'local' => 'id_calendrier',
             'foreign' => 'id',
             'onDelete' => 'CASCADE'));
    }
}