<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class tbl_devoirTable extends Doctrine_Table
{
    public static function getInstance()
    {
        return Doctrine_Core::getTable('tbl_devoir');
    }
    public function getDevoirEleves($pnJour, $pnIdCahier, $pbGroupe) {
      if ($pbGroupe == false) {
          $oCahier = Doctrine::getTable('tbl_cahier_texte')->find($pnIdCahier);
          $oCahierGroupe = Doctrine::getTable('tbl_cahier_texte')->findBySql('id_user is null and id_groupe = ?', array($oCahier->getIdGroupe()), Doctrine_core::HYDRATE_RECORD);
          if ($oCahierGroupe->count() > 0) {
              $nIdCahierGroupe = $oCahierGroupe[0]->getId();
          }
      }
      $query = $this->createQuery('d');
      $query->where('id_jour=?', array($pnJour));
      if (isset($nIdCahierGroupe)) {
        $query->andWhereIn('id_cahier_texte', array($pnIdCahier, $nIdCahierGroupe));
      } else {
        $query->andWhere('id_cahier_texte=?', array($pnIdCahier));
      }
      $query->orderBy('d.is_closed asc, d.date_devoir desc');      
      return $query;
    }
}